package be.iminds.ilabt.jfed.ui.javafx.userlogin;

import be.iminds.ilabt.jfed.ui.javafx.userlogin.UserLoginController.UserLoginControllerListener;
import com.cathive.fx.guice.GuiceFXMLLoader;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.Window;

import javax.inject.Inject;
import java.io.IOException;
import java.net.URL;

/**
 * User: twalcari
 * Date: 11/28/2014
 * Time: 17:12
 */
public class UserLoginFactory {
   // private static final Logger LOG = LoggerFactory.getLogger(UserLoginFactory.class);


    @Inject
    private GuiceFXMLLoader fxmlLoader;

    /**
     * doesn't wait, but you can use the listener for feedback
     */
    public Stage showUserLogin(boolean requireAllUserInfo, Window parentWindow, UserLoginControllerListener listener) {
        try {
            URL location = UserLoginController.class.getResource("UserLogin.fxml");

            GuiceFXMLLoader.Result result = fxmlLoader.load(location);
            final BorderPane root = result.getRoot();
            final UserLoginController controller = result.getController();

            Stage userloginStage = new Stage();

            controller.setStage(userloginStage);
            controller.addListener(listener);
            controller.setRequireAllUserInfo(requireAllUserInfo);

            Scene scene = new Scene(root);

            userloginStage.initModality(Modality.WINDOW_MODAL);
            userloginStage.initOwner(parentWindow);
            userloginStage.setScene(scene);
            userloginStage.sizeToScene();
            userloginStage.setOnCloseRequest(windowEvent -> {
           //     LOG.debug("Advanced User Login window close requested: skipping login");
                controller.fireUserLoginControllerListeners(false);
            });

            userloginStage.show();
            return userloginStage;
        } catch (IOException e) {
           // LOG.error("Something went wrong showing the User Login Screen: " + e.getMessage(), e);
            throw new RuntimeException("Something went wrong showing the User Login Screen: " + e.getMessage(), e);
        }
    }
}
