package be.iminds.ilabt.jfed.experimenter_gui.call_gui;

import be.iminds.ilabt.jfed.highlevel.controller.JavaFXTaskThread;
import javafx.fxml.FXMLLoader;
import javafx.scene.control.ListCell;
import javafx.scene.control.ListView;

import java.io.IOException;
import java.net.URL;

/**
 * CallList
 */
public class TaskList extends ListView<JavaFXTaskThread.FXTaskExecution> {
    public TaskList() {
        URL location = getClass().getResource("CallList.fxml");
        assert location != null;
        FXMLLoader fxmlLoader = new FXMLLoader(location);
        fxmlLoader.setRoot(this);
        fxmlLoader.setController(this);

        try {
            fxmlLoader.load();

            this.setCellFactory(callListView -> new CallCell());
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    private static class CallCell extends ListCell<JavaFXTaskThread.FXTaskExecution> {
        private final TaskLabel label = new TaskLabel();

        @Override
        public void updateItem(final JavaFXTaskThread.FXTaskExecution item, boolean empty) {
            super.updateItem(item, empty);

            if (item == null) {
                label.setTask(null);
                setGraphic(null);
            } else {
                label.setTask(item);
                setGraphic(label);
            }
        }
    }
}
