package be.iminds.ilabt.jfed.experimenter_gui.canvas.impl;

import be.iminds.ilabt.jfed.experimenter_gui.JFedConfiguration;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.ExperimentCanvas;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.TestbedAwareCanvasNode;
import be.iminds.ilabt.jfed.experimenter_gui.util.ImageSize;
import be.iminds.ilabt.jfed.experimenter_gui.util.ImageUtil;
import be.iminds.ilabt.jfed.highlevel.model.AuthorityList;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXRspecNode;

/**
 * User: twalcari
 * Date: 11/8/13
 * Time: 12:13 PM
 */
public class RspecCanvasNode extends TestbedAwareCanvasNode {
    private final FXRspecNode node;

    public RspecCanvasNode(FXRspecNode node, ExperimentCanvas experimentCanvas, AuthorityList authorityList, JFedConfiguration config) {
        super(experimentCanvas, node.getClientId()/*text*/, ImageUtil.getRspecNodeImage(config, node, ImageSize.SMALL), authorityList, config);
        this.node = node;

        idProperty().bind(node.clientIdProperty());
        textProperty().bind(node.clientIdProperty());

        layoutXProperty().bindBidirectional(node.editorXProperty());
        layoutYProperty().bindBidirectional(node.editorYProperty());

        //special case: if no jFed location, but a flack location DOES exist, set jFed location to flack location
        if (node.getEditorX() < 0.0 && node.getEditorY() < 0.0 && node.getFlackEditorX() >= 0) {
            node.setEditorX(node.getFlackEditorX());
            node.setEditorY(node.getFlackEditorY());
        }

        node.nodeDescriptionIdProperty().addListener(observable -> setImage(ImageUtil.getRspecNodeImage(config, RspecCanvasNode.this.node, ImageSize.SMALL)));

        componentManagerId.bind(node.componentManagerIdProperty());
    }


    public FXRspecNode getRspecNode() {
        return node;
    }

}
