package be.iminds.ilabt.jfed.experimenter_gui.controller.controller.action;

import be.iminds.ilabt.jfed.experimenter_gui.controller.model.ControllerModel;
import be.iminds.ilabt.jfed.experimenter_gui.controller.view.IControllerComponent;
import be.iminds.ilabt.jfed.experimenter_gui.controller.view.UpdateEvent;
import be.iminds.ilabt.jfed.rspec.model.controller.ExperimentCommand;

/**
 * @author Cedric
 */
public class AddCommandAction implements IAction {
    private final ExperimentCommand command;

    public AddCommandAction(ExperimentCommand command) {
        this.command = command;
    }

    @Override
    public boolean execute(ControllerModel model, IControllerComponent view) {
        model.addCommand(command);
        view.update(UpdateEvent.ADD_COMMAND, command);
        return true;
    }

    @Override
    public boolean undo(ControllerModel model, IControllerComponent view) {
        model.deleteCommand(command);
        view.update(UpdateEvent.DELETE_COMMAND, command);
        return true;
    }

}
