package be.iminds.ilabt.jfed.experimenter_gui.preferences.subsections;

import be.iminds.ilabt.jfed.experimenter_gui.preferences.AbstractPreferencesSubPane;
import be.iminds.ilabt.jfed.lowlevel.GeniUser;
import be.iminds.ilabt.jfed.lowlevel.userloginmodel.UserLoginModelManager;
import be.iminds.ilabt.jfed.ui.javafx.GlyphUtils;
import be.iminds.ilabt.jfed.util.GeniUrn;
import be.iminds.ilabt.jfed.util.IOUtils;
import be.iminds.ilabt.jfed.util.KeyUtil;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.stage.FileChooser;
import org.controlsfx.dialog.Wizard;
import org.controlsfx.glyphfont.FontAwesome;
import org.controlsfx.validation.Validator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.inject.Inject;
import java.io.File;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import java.util.List;
import java.util.function.Predicate;

/**
 * LoginPane
 */
public class LoginPane extends AbstractPreferencesSubPane {
    private final static Logger LOG = LoggerFactory.getLogger(LoginPane.class);
    private static final String PKCS12_FILE_EXTENSION = ".p12";
    private static final String PEM_FILE_EXTENSION = ".pem";

    @FXML
    private Button pkcs12Button;
    @FXML
    private Button pemButton;
    @FXML
    private TextField urnTextField;

    @FXML
    private BorderPane root;

    @Override
    public Node getRoot() {
        return root;
    }

    private final UserLoginModelManager userLoginModelManager;

    @Inject
    LoginPane(UserLoginModelManager userLoginModelManager) {
        super("User Details", false/*advanced*/);
        this.userLoginModelManager = userLoginModelManager;
    }

    @FXML
    private void initialize() {

        urnTextField.setText(this.userLoginModelManager.getUserUrnString());

//        webEngine = reservationWebView.getEngine();
//
//        reservationWebView.getEngine().getLoadWorker().stateProperty().addListener(new ChangeListener<Worker.State>() {
//            @Override
//            public void changed(ObservableValue ov, Worker.State oldState, Worker.State newState) {
//                LOG.debug("load state changed to "+newState);
//                if (newState == Worker.State.SUCCEEDED)
//                    bindLinks();
//            }
//        });

//        Runnable r = new Runnable() {
//            @Override
//            public void run() {
//                requestWithUserAuthentication("https://www.wilab2.ilabt.iminds.be:12369/reservation/sfareservation.php3");
//            }
//        };
//        Thread fetchReservationPageThread = new Thread(r, "FetchReservationPageThread");
//        fetchReservationPageThread.run();
    }

//    private void bindLinks() {
//        LOG.debug("searching links in page");
//        EventListener listener = new EventListener() {
//            @Override
//            public void handleEvent(Event ev) {
//                String domEventType = ev.getType();
//                LOG.debug("handleEvent with EventType: " + domEventType);
//                if (!domEventType.equals(EVENT_TYPE_CLICK))
//                    return;
//
//                final String href = ((Element)ev.getTarget()).getAttribute("href");
//
//                if (href == null) {
//                    LOG.debug("link without href clicked");
//                    return;
//                }
//                Platform.runLater(new Runnable() {
//                    @Override
//                    public void run() {
//                        requestWithUserAuthentication(href);
//                    }
//                });
//            }
//        };
//
//        Document doc = reservationWebView.getEngine().getDocument();
//        NodeList nodeList = doc.getElementsByTagName("a");
//        LOG.debug("found "+nodeList.getLength()+" links in page");
//        for (int i = 0; i < nodeList.getLength(); i++) {
//            LOG.debug("binding link in page");
//            ((EventTarget) nodeList.item(i)).addEventListener(EVENT_TYPE_CLICK, listener, false);
//        }
//        nodeList = doc.getElementsByTagName("input");
//        LOG.debug("found "+nodeList.getLength()+" inputs in page");
//        for (int i = 0; i < nodeList.getLength(); i++) {
//            LOG.debug("binding input in page");
//            ((EventTarget) nodeList.item(i)).addEventListener(EVENT_TYPE_CLICK, listener, false);
//        }
//    }

//    public void requestWithUserAuthentication(String url) {
//        LOG.debug("loading reservation page url: "+url);
//
//        if (!experimenterModel.getGeniUserProvider().isUserLoggedIn())
//            return;
//
//        GeniUser user = experimenterModel.getGeniUserProvider().getLoggedInGeniUser();
//
//        SfaAuthority authority =
//                experimenterModel.getAuthorityListModel().getByUrn(
//                        "urn:publicid:IDN+wilab2.ilabt.iminds.be+authority+cm",
//                        AuthorityListModel.SubAuthMatchingMode.ALLOW_TOPLEVEL);
//        assert authority != null;
//
//        final JFedTrustStore conTrustStore = new JFedTrustStore(experimenterModel.getSfaConnectionPool().getBaseTrustStore());
//        if (authority.hasPemSslTrustCerts()) {
//            conTrustStore.addTrustedPemCertificateIfNotAdded(authority.getPemSslTrustCerts());
//            conTrustStore.addAllowedServerCertificateHostnameAliases(authority.getAllowedCertificateHostnameAliases());
//        }
//        if (user.getUserAuthority() != null) {
//            if (user.getUserAuthority().hasPemSslTrustCerts())
//                conTrustStore.addTrustedPemCertificateIfNotAdded(user.getUserAuthority().getPemSslTrustCerts());
//            conTrustStore.addAllowedServerCertificateHostnameAliases(user.getUserAuthority().getAllowedCertificateHostnameAliases());
//        }
//
//        JFedConnection.ProxyInfo proxyInfo = null;
//        List<X509Certificate> clientCertificateChain = user.getClientCertificateChain();
//        PrivateKey privateKey = user.getPrivateKey();
//        String serverUrlStr = url;
//        KeyStore trustStore = conTrustStore.getTrustStore();
//        final Collection<String> allowedCertificateHostnameAliases = authority.getAllowedCertificateHostnameAliases();
//        boolean debugMode = false;
//        final HandleUntrustedCallback handleUntrustedCallback = null;
//
//        try {
//            DefaultHttpClient httpClient = HttpsClientWithUserAuthenticationFactory.getHttpClient(proxyInfo, clientCertificateChain, privateKey, serverUrlStr,
//                    trustStore, allowedCertificateHostnameAliases, debugMode, handleUntrustedCallback);
//
//
//            HttpUriRequest httpCall = new HttpGet(url);
////            httpCall.addHeader("Accept", "*/*");
////            httpCall.addHeader("Accept-Encoding", "gzip, deflate");
//
//            HttpResponse response = httpClient.execute(httpCall);
//
//            LOG.debug("call returned statusline \"" + response.getStatusLine() + "\"");
//
////            StringBuilder httpResponseHeaders = new StringBuilder(200);
////            for (Header header : response.getAllHeaders())
////                httpResponseHeaders.append(header.toString() + "\n");
////            httpResponseHeaders.append("\n");
//
//            HttpEntity entity = response.getEntity();
//
//            String resultContent = IOUtils.streamToString(entity.getContent(), "UTF-8");
//
//            showReservationContent(resultContent);
//        } catch (JFedException /*| ClientProtocolException*/ | IOException e) {
//            LOG.error("Exception while fetching reservation page", e);
//            String exceptionString = TextUtil.exceptionToString(e);
//            showReservationContent(exceptionString);
//        }
//    }
//
//    public void showReservationContent(final String content) {
//        Platform.runLater(new Runnable() {
//            @Override
//            public void run() {
//                webEngine.loadContent(content);
//            }
//        });
//    }

    @FXML
    protected void onSavePKCS12Action() {
        assert (userLoginModelManager.isUserLoggedIn());

        final GeniUser user = userLoginModelManager.getLoggedInGeniUser();
        final GeniUrn userUrn = user.getUserUrn();
        final String niceName = userUrn.getEncodedTopLevelAuthority() + "_" + userUrn.getEncodedResourceName();

        Path defaultPath = Paths.get(System.getProperty("user.home"), niceName + PKCS12_FILE_EXTENSION);

        StringProperty filename = new SimpleStringProperty(defaultPath.toString());

        Wizard wizard = new Wizard(pkcs12Button, "Export your credentials as a PKCS #12 certificate");


        TextField locationTextField = new TextField();
        locationTextField.setPrefColumnCount(30);
        locationTextField.textProperty().bindBidirectional(filename);

        Button browseButton = new Button("Browse ...");
        browseButton.setOnAction(ae -> {
            FileChooser fc = new FileChooser();
            fc.setInitialFileName(filename.get());
            fc.setInitialDirectory(new File(System.getProperty("user.home")));
            fc.getExtensionFilters().add(new FileChooser.ExtensionFilter("PKCS #12 file (*" + PKCS12_FILE_EXTENSION + ")", "*" + PKCS12_FILE_EXTENSION));
            fc.setTitle("Export your credentials as a PKCS #12 certificate");

            File pkcs12File = fc.showSaveDialog(browseButton.getScene().getWindow());

            if (pkcs12File != null) {
                filename.setValue(pkcs12File.getAbsolutePath());
            }
        });


        VBox locationVContainer = new VBox(5);
        HBox locationHContainer = new HBox(5);
        locationHContainer.getChildren().addAll(locationTextField, browseButton);
        locationVContainer.getChildren().addAll(new Label("Specify where you want to save your PKCS #12-file:"), locationHContainer);
        Wizard.WizardPane locationPane = new Wizard.WizardPane() {


            @Override
            public void onEnteringPage(Wizard wizard) {
                wizard.getValidationSupport().registerValidator(locationTextField,
                        Validator.createPredicateValidator(new Predicate<String>() {
                            @Override
                            public boolean test(String s) {
                                if (s == null) return false;
                                File file = new File(s);
                                return (file.getParentFile() != null && file.getParentFile().exists());
                            }
                        }, "Please provide a valid file path"));
            }
        };
        locationPane.setHeaderText("Choose the export location");
        locationPane.setGraphic(GlyphUtils.createDialogGlyph(FontAwesome.Glyph.FOLDER_OPEN_ALT, Color.ORANGE));
        locationPane.setContent(locationVContainer);


        VBox passwordContainer = new VBox(5);
        Label label = new Label("Enter the new password for the created PKCS12 file:");
        final PasswordField passwordTextField = new PasswordField();
        passwordTextField.setPrefColumnCount(30);
        passwordContainer.getChildren().addAll(label, passwordTextField);

        Wizard.WizardPane passwordPane = new Wizard.WizardPane() {
            @Override
            public void onEnteringPage(Wizard wizard) {
                passwordTextField.requestFocus();

//                wizard.getValidationSupport().registerValidator(passwordTextField,
//                        Validator.createEmptyValidator("Password cannot be empty!"));
            }
        };
        passwordPane.setHeaderText("Secure your PKCS#12-file");
        passwordPane.setGraphic(GlyphUtils.createDialogGlyph(FontAwesome.Glyph.KEY, Color.ORANGE));
        passwordPane.setContent(passwordContainer);


        Label finishedLabel = new Label();

        Wizard.WizardPane finishPane = new Wizard.WizardPane() {
            @Override
            public void onEnteringPage(Wizard wizard) {
                boolean success =
                        savePKCS12File(new File(filename.get()), passwordTextField.getText());

                if (success) {
                    finishedLabel.setText("Your PKCS #12-file was successfully created");
                    finishedLabel.setGraphic(GlyphUtils.createSmallGlyph(FontAwesome.Glyph.CHECK, Color.GREEN));
                } else {
                    finishedLabel.setText("A problem occurred while saving your certificate. Please try again!");
                    finishedLabel.setGraphic(GlyphUtils.createSmallGlyph(FontAwesome.Glyph.TIMES_CIRCLE, Color.RED));
                }

            }
        };
        finishPane.setHeaderText("Export finished");
        finishPane.setGraphic(GlyphUtils.createDialogGlyph(FontAwesome.Glyph.KEY, Color.GREEN));
        finishPane.setContent(finishedLabel);

        wizard.setFlow(new Wizard.LinearFlow(locationPane, passwordPane, finishPane));

        wizard.showAndWait();
    }

    private boolean savePKCS12File(File pkcs12File, String passwordString) {
        assert (userLoginModelManager.isUserLoggedIn());

        final GeniUser user = userLoginModelManager.getLoggedInGeniUser();
        final GeniUrn userUrn = user.getUserUrn();
        final String niceName = userUrn.getEncodedTopLevelAuthority() + "_" + userUrn.getEncodedResourceName();

        //build the PKCS12-file
        final PrivateKey pk = user.getPrivateKey();
        final List<X509Certificate> certs = user.getClientCertificateChain();
        final Certificate[] chain = new Certificate[certs.size()];
        for (int i = 0; i < certs.size(); i++)
            chain[i] = certs.get(i);


        char[] keyStorePass = passwordString.toCharArray();
        KeyStore keyStore;
        try {
            keyStore = KeyStore.getInstance("jks");
            keyStore.load(null/*inputstream*/, null/*pass*/);
            keyStore.setKeyEntry(niceName, pk, keyStorePass/*pass*/, chain);

            byte[] pkcs12 = KeyUtil.keyStoreToPKCS12Bytes(keyStore, passwordString, passwordString);
            IOUtils.byteArrayToFile(pkcs12File, pkcs12);

            LOG.info("Saved user login as PKCS12 to " + pkcs12File + "  (" + pkcs12.length + " bytes)");

            return true;

        } catch (Exception e) {
            LOG.error("Failed to convert and save PK12: " + e.getMessage(), e);
            return false;
        }
    }

    @FXML
    protected void onSavePEMAction() {

        assert (userLoginModelManager.isUserLoggedIn());

        final GeniUser user = userLoginModelManager.getLoggedInGeniUser();
        final GeniUrn userUrn = user.getUserUrn();
        final String niceName = userUrn.getEncodedTopLevelAuthority() + "_" + userUrn.getEncodedResourceName();

        Path defaultPath = Paths.get(System.getProperty("user.home"), niceName + PEM_FILE_EXTENSION);

        StringProperty filename = new SimpleStringProperty(defaultPath.toString());

        Wizard wizard = new Wizard(pemButton, "Export your credentials as a PEM certificate");


        TextField locationTextField = new TextField();
        locationTextField.setPrefColumnCount(30);
        locationTextField.textProperty().bindBidirectional(filename);

        Button browseButton = new Button("Browse ...");
        browseButton.setOnAction(ae -> {
            FileChooser fc = new FileChooser();
            fc.setInitialFileName(filename.get());
            fc.setInitialDirectory(new File(System.getProperty("user.home")));
            fc.getExtensionFilters().add(new FileChooser.ExtensionFilter("PEM file (*" + PEM_FILE_EXTENSION + ")", "*" + PEM_FILE_EXTENSION));
            fc.setTitle("Export your credentials as a PEM certificate");

            File pemFile = fc.showSaveDialog(browseButton.getScene().getWindow());

            if (pemFile != null) {
                filename.setValue(pemFile.getAbsolutePath());
            }
        });


        VBox locationVContainer = new VBox(5);
        HBox locationHContainer = new HBox(5);
        locationHContainer.getChildren().addAll(locationTextField, browseButton);
        locationVContainer.getChildren().addAll(new Label("Specify where you want to save your PEM-file:"), locationHContainer);
        Wizard.WizardPane locationPane = new Wizard.WizardPane() {


            @Override
            public void onEnteringPage(Wizard wizard) {
                wizard.getValidationSupport().registerValidator(locationTextField,
                        Validator.createPredicateValidator(new Predicate<String>() {
                            @Override
                            public boolean test(String s) {
                                if (s == null) return false;
                                File file = new File(s);
                                return (file.getParentFile() != null && file.getParentFile().exists());
                            }
                        }, "Please provide a valid file path"));
            }
        };
        locationPane.setHeaderText("Choose the export location");
        locationPane.setGraphic(GlyphUtils.createDialogGlyph(FontAwesome.Glyph.FOLDER_OPEN_ALT, Color.ORANGE));
        locationPane.setContent(locationVContainer);


        VBox passwordContainer = new VBox(5);
        Label label = new Label("Enter the new password for the created PEM file:");
        final PasswordField passwordTextField = new PasswordField();
        passwordTextField.setPrefColumnCount(30);
        passwordContainer.getChildren().addAll(label, passwordTextField);

        Wizard.WizardPane passwordPane = new Wizard.WizardPane() {
            @Override
            public void onEnteringPage(Wizard wizard) {

                passwordTextField.requestFocus();

//                wizard.getValidationSupport().registerValidator(passwordTextField,
//                        Validator.createEmptyValidator("Password cannot be empty!"));
            }
        };
        passwordPane.setHeaderText("Secure your PEM-file");
        passwordPane.setGraphic(GlyphUtils.createDialogGlyph(FontAwesome.Glyph.KEY, Color.ORANGE));
        passwordPane.setContent(passwordContainer);


        Label finishedLabel = new Label();

        Wizard.WizardPane finishPane = new Wizard.WizardPane() {
            @Override
            public void onEnteringPage(Wizard wizard) {
                boolean success =
                        savePEMFile(new File(filename.get()), passwordTextField.getText());

                if (success) {
                    finishedLabel.setText("Your PEM-file was successfully created");
                    finishedLabel.setGraphic(GlyphUtils.createSmallGlyph(FontAwesome.Glyph.CHECK, Color.GREEN));
                } else {
                    finishedLabel.setText("A problem occurred while saving your certificate. Please try again!");
                    finishedLabel.setGraphic(GlyphUtils.createSmallGlyph(FontAwesome.Glyph.TIMES_CIRCLE, Color.RED));
                }

            }
        };
        finishPane.setHeaderText("Export finished");
        finishPane.setGraphic(GlyphUtils.createDialogGlyph(FontAwesome.Glyph.KEY, Color.GREEN));
        finishPane.setContent(finishedLabel);

        wizard.setFlow(new Wizard.LinearFlow(locationPane, passwordPane, finishPane));

        wizard.showAndWait();

    }

    private boolean savePEMFile(File pemFile, String passwordString) {
        assert (userLoginModelManager.isUserLoggedIn());

        final GeniUser user = userLoginModelManager.getLoggedInGeniUser();

        //build the PKCS12-file
        try {
            final PrivateKey pk = user.getPrivateKey();
            final List<X509Certificate> certs = user.getClientCertificateChain();

            char[] pemKey = KeyUtil.privateKeyToAnyPem(pk, passwordString.toCharArray());
            String pemCerts = KeyUtil.x509certificateChainToPem(certs);
            String pem = new String(pemKey) + "" + pemCerts;
            IOUtils.stringToFile(pemFile, pem);


            LOG.info("Saved user login as pem to " + pemFile + "  (" + pem.length() + " chars)");

            return true;

        } catch (Exception e) {
            LOG.error("Failed to convert and save PEM: " + e.getMessage(), e);
            return false;
        }
    }


    @Override
    public boolean check() {
        return true;
    }

    @Override
    public boolean save() {
        return true;
    }
}
