package be.iminds.ilabt.jfed.experimenter_gui.slice;

import be.iminds.ilabt.jfed.experimenter_gui.JFedConfiguration;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.impl.CanvasNodeFactory;
import be.iminds.ilabt.jfed.experimenter_gui.slice.actions.ExperimentActionsFactory;
import be.iminds.ilabt.jfed.experimenter_gui.slice.tasks.ExperimentTasksFactory;
import be.iminds.ilabt.jfed.experimenter_gui.util.SSHTerminalUtil;
import be.iminds.ilabt.jfed.highlevel.controller.HighLevelController;
import be.iminds.ilabt.jfed.highlevel.model.AuthorityList;
import be.iminds.ilabt.jfed.lowlevel.GeniUserProvider;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXModelRspec;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 12/8/2014
 * Time: 14:15
 */
@Singleton
public class SliceExperimentCanvasFactory {


    private final JFedConfiguration config;
    private final CanvasNodeFactory canvasNodeFactory;
    private final GeniUserProvider geniUserProvider;
    private final AuthorityList authorityList;
    private final HighLevelController hlc;
    private final NodePropertiesDialogFactory nodePropertiesDialogFactory;
    private final ExperimentTasksFactory experimentTasksFactory;
    private final ExperimentActionsFactory experimentActionsFactory;
    private final SSHTerminalUtil sshTerminalUtil;

    @Inject
    public SliceExperimentCanvasFactory(JFedConfiguration config, CanvasNodeFactory canvasNodeFactory,
                                        GeniUserProvider geniUserProvider, AuthorityList authorityList,
                                        HighLevelController hlc, NodePropertiesDialogFactory nodePropertiesDialogFactory,
                                        ExperimentTasksFactory experimentTasksFactory,
                                        ExperimentActionsFactory experimentActionsFactory, SSHTerminalUtil sshTerminalUtil) {
        this.config = config;
        this.canvasNodeFactory = canvasNodeFactory;
        this.geniUserProvider = geniUserProvider;
        this.authorityList = authorityList;
        this.hlc = hlc;
        this.nodePropertiesDialogFactory = nodePropertiesDialogFactory;
        this.experimentTasksFactory = experimentTasksFactory;
        this.experimentActionsFactory = experimentActionsFactory;
        this.sshTerminalUtil = sshTerminalUtil;
    }

    public SliceExperimentCanvas createSliceExperimentCanvas(ExperimentController experimentController, FXModelRspec model) {
        return new SliceExperimentCanvas(experimentController, model, config, canvasNodeFactory, experimentActionsFactory, experimentTasksFactory, geniUserProvider,
                authorityList, hlc, nodePropertiesDialogFactory, sshTerminalUtil);
    }
}
