package be.iminds.ilabt.jfed.experimenter_gui.slice.actions;

import be.iminds.ilabt.jfed.experimenter_gui.slice.ExperimentController;
import be.iminds.ilabt.jfed.experimenter_gui.slice.tasks.ExperimentTasksFactory;
import be.iminds.ilabt.jfed.experimenter_gui.slice.tasks.StopExperimentTask;
import javafx.application.Platform;
import javafx.stage.Window;
import org.controlsfx.control.ButtonBar;
import org.controlsfx.control.action.Action;
import org.controlsfx.dialog.Dialog;
import org.controlsfx.dialog.DialogAction;

/**
 * User: twalcari
 * Date: 2/2/2015
 * Time: 17:37
 */
public class StopExperimentAction extends ExperimentAction {

    StopExperimentAction(Window parentWindow, ExperimentController experimentController, ExperimentTasksFactory experimentTasksFactory) {
        super(parentWindow, experimentController, experimentTasksFactory);
    }


    @Override
    public void run() {
        assert(Platform.isFxApplicationThread());

        Dialog confirmDialog = new Dialog(null, "Terminating experiment");
        confirmDialog.setContent(
                String.format("Are you sure you want to release all the resources in this experiment '%s'?", experiment.getName()));

        DialogAction noAction = new DialogAction("No", ButtonBar.ButtonType.NO, true, true, true);
        DialogAction yesAction = new DialogAction("Yes", ButtonBar.ButtonType.YES, false, true, false);


        confirmDialog.getActions().setAll(yesAction, noAction, Dialog.ACTION_CANCEL);

        Action result = confirmDialog.show();
        if (result != yesAction)
            return;

        StopExperimentTask stopExperimentTask = experimentTasksFactory.createStopExperimentTask(experiment);
        experimentController.submitExperimentTask(stopExperimentTask);
    }
}
