package be.iminds.ilabt.jfed.experimenter_gui.slice.ribbon_tabs;

import be.iminds.ilabt.jfed.experimenter_gui.dialogs.DialogsFactory;
import be.iminds.ilabt.jfed.experimenter_gui.slice.actions.ExperimentActionsFactory;
import be.iminds.ilabt.jfed.experimenter_gui.slice.tasks.ExperimentTasksFactory;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;

import java.io.IOException;

/**
 * User: twalcari
 * Date: 7/1/2014
 * Time: 17:31
 */
public class TopologyViewerRibbonTab extends SliceRibbonTab {

    private static final String TOPOLOGY_VIEWER_RIBBON_TAB_FXML = "TopologyViewerRibbonTab.fxml";

    public TopologyViewerRibbonTab(DialogsFactory dialogsFactory, ExperimentActionsFactory experimentActionsFactory, ExperimentTasksFactory experimentTasksFactory) {
        FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource(TOPOLOGY_VIEWER_RIBBON_TAB_FXML));

        fxmlLoader.setRoot(this);
        fxmlLoader.setController(this);
        fxmlLoader.setControllerFactory(aClass -> {
            if (aClass == GenericSliceRibbonComponentGroupController.class) {
                return new GenericSliceRibbonComponentGroupController(TopologyViewerRibbonTab.this, experimentActionsFactory, experimentTasksFactory, dialogsFactory);
            } else if (aClass == AdvancedSliceRibbonComponentGroupController.class) {
                return new AdvancedSliceRibbonComponentGroupController(TopologyViewerRibbonTab.this, dialogsFactory);
            }
            throw new RuntimeException("Unexpected class in ControllerFactory: " + aClass.getName());
        });


        try {
            fxmlLoader.load();
        } catch (IOException exception) {
            throw new RuntimeException(exception);
        }

        setOnSelectionChanged(event -> {
            if (isSelected() && !getActiveExperimentViewController().isCanvasVisible()) {
                getActiveExperimentViewController().switchToModelView();
            }
        });
    }


    @FXML
    private void onAutoLayoutAction() {
        getActiveExperimentViewController().getModelSliceView().getCanvas().arrangeNodesOnCircle();
    }

        /*
        Zoom section
     */

    @FXML
    public void onZoomInAction() {
        getActiveExperimentViewController().getModelSliceView().getCanvas().zoomIn();
    }

    @FXML
    public void onZoomOutAction() {
        getActiveExperimentViewController().getModelSliceView().getCanvas().zoomOut();
    }

    @FXML
    public void onResetZoomAction() {
        getActiveExperimentViewController().getModelSliceView().getCanvas().setZoom(1);
    }

}
