package be.iminds.ilabt.jfed.experimenter_gui.util;

import javafx.application.HostServices;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.inject.Singleton;
import java.net.URL;

/**
 * User: twalcari
 * Date: 2/4/2015
 * Time: 10:16
 */
@Singleton
public class BrowserUtil {
    private static final Logger LOG = LoggerFactory.getLogger(BrowserUtil.class);

    private final Provider<HostServices> hostServicesProvider;

    @Inject
    public BrowserUtil(Provider<HostServices> hostServicesProvider) {
        this.hostServicesProvider = hostServicesProvider;
    }

    public boolean openUrlInBrowser(URL url){

        //open browser
        hostServicesProvider.get().showDocument(url.toExternalForm());
        return true;

        //this legacy code should not be needed anymore:


//        if (OSDetector.findOS().equals(OSDetector.OS.UNIX)) {
//            try {
//                ArrayList<String> command = new ArrayList<>();
//                command.add("xdg-open");
//                command.add(url.toExternalForm());
//                Process p = Runtime.getRuntime().exec(command.toArray(new String[command.size()]));
//
//                BufferedReader input = new BufferedReader(new InputStreamReader(p.getErrorStream()));
//                p.getOutputStream().close();
////                        String line = input.readLine();
//                input.close();
//
//                try {
//                    p.waitFor();
//                } catch (InterruptedException e) {
//                    //ignore
//                }
//            } catch (IOException e) {
//                e.printStackTrace();
//            }
//
//
//        } else {
//
//            if (java.awt.Desktop.isDesktopSupported()) {
//                try {
//                    java.awt.Desktop.getDesktop().browse(new URI(url.toExternalForm()));
//                } catch (IOException | URISyntaxException e) {
//                    LOG.warn("Exception starting browser", e);
//                    JFDialogs.create()
//                            .owner(null)
//                            .message("Problem opening browser. Try to open the URL manually: " + url.toExternalForm())
//                            .allowCopyMessage()
//                            .showException(e);
//                }
//            } else {
//                JFDialogs.create()
//                        .owner(null)
//                        .message("System does not support opening browser. Try to open the URL manually: " + url.toExternalForm())
//                        .allowCopyMessage()
//                        .showWarning();
//            }
//        }
    }

}
