package be.iminds.ilabt.jfed.highlevel.history;

import be.iminds.ilabt.jfed.call_log_output.SerializableApiCallDetails;
import be.iminds.ilabt.jfed.log.ApiCallDetails;
import be.iminds.ilabt.jfed.log.Logger;
import be.iminds.ilabt.jfed.log.ResultListener;
import javafx.application.Platform;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * ApiCallHistory
 */
@Singleton
public class ApiCallHistory implements ResultListener {
    private final Logger logger;

    @Inject
    public ApiCallHistory(Logger logger) {
        this.logger = logger;
        logger.addResultListener(this);
    }

    final ObservableList<SerializableApiCallDetails> history = FXCollections.observableArrayList();

    public ObservableList<SerializableApiCallDetails> getHistory() {
        return history;
    }

    @Override
    public void onResult(final ApiCallDetails result) {
        //this may be added asynchronously
        Platform.runLater(() -> history.add(new SerializableApiCallDetails(result)));
    }
}
