package be.iminds.ilabt.jfed.highlevel.model;

/**
 * SliverMapper
 *
 * Based on all input, slivermapper will link components (identified by URN and client_id) and slivers in a specific slice, on a specific aggregate.
 *
 * Reason:
 *    When creating a sliver, it is possible that multiple slivers are created.
 *    At least one will be created, which can contain everything,
 *    but it is also possible that a sliver is created for each node and link.
 *    Some call details:
 *    - In AMv3, it is always clear
 *    - In the AMv2 CreateSliver reply, it is unknown how many slivers are created
 *    - In emulab AMv2, the manifest contains a sliver_id tag, which can be used to deterimine the sliver for each component.
 *    - In AMv2 SliverStatus, the geni_resources array contains a list of slivers but these cannot be linked back to components
 *
 */
public class SliverMapper {

}
