package be.iminds.ilabt.jfed;

import be.iminds.ilabt.jfed.lowlevel.api_scripts.GetUsersInProject;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.impl.AutomaticAggregateManagerWrapper;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.impl.AutomaticUserAndSliceApiWrapper;
import be.iminds.ilabt.jfed.lowlevel.connection.BasicConnectionFactory;
import be.iminds.ilabt.jfed.lowlevel.connection.ConnectionFactory;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedConnectionProvider;
import be.iminds.ilabt.jfed.lowlevel.connection.SfaConnectionPool;
import be.iminds.ilabt.jfed.util.JFedTrustStore;
import com.google.inject.AbstractModule;

import javax.inject.Singleton;

/**
 * CoreModule
 */
public class CoreModule extends AbstractModule {
    @Override
    protected void configure() {
        bind(JFedTrustStore.class).in(Singleton.class);
        bind(JFedConnectionProvider.class).to(SfaConnectionPool.class).in(Singleton.class);
        bind(GetUsersInProject.class);
        bind(ConnectionFactory.class).to(BasicConnectionFactory.class).in(Singleton.class);

        bind(AutomaticAggregateManagerWrapper.AutomaticAggregateManagerWrapperFactory.class).
                to(AutomaticAggregateManagerWrapper.BasicAutomaticAggregateManagerWrapperFactory.class).in(Singleton.class);

        bind(AutomaticUserAndSliceApiWrapper.AutomaticUserAndSliceApiWrapperFactory.class).
                to(AutomaticUserAndSliceApiWrapper.BasicAutomaticUserAndSliceApiWrapperFactory.class).in(Singleton.class);
    }
}
